/*
 *
 * Copyright (C) 2009 Tomas Mazanec
 *
 * Author:   Tomas Mazanec <mazanec at utia.cas.cz>
 * Created:  Fri Aug 28 10:16:54 CEST 2009
 *
 * Application of CUDA in DSP algorithms 
 *	- Cross Ambiguity Function (CAF) implementation
 *
 */

#ifndef _CAF_KERNEL_H_
#define _CAF_KERNEL_H_


#define MAXTHREADS 512

////////////////////////////////////////////////////////////////////////////////

static __global__ void
cafMulKernel( Complex* g_sig1, Complex* g_sig2, Complex* g_sigt,
	    const unsigned int N, const unsigned int m, const unsigned int NL)
{

    // shared memory,the size is determined by the host application
    extern  __shared__  float sdata[];
/*
    Complex *sig1 = (Complex *) sdata;
    Complex *sig2 = (Complex *) &sig1[MAXTHREADS];
    Complex *sigt = (Complex *) &sig2[MAXTHREADS];
*/    
    // thread index
//    const unsigned int tid = threadIdx.x;
    // actual No. of threads
/*    const unsigned int NT = blockDim.x;
    // block index
    const unsigned int bid = blockIdx.x;
    // No. of blocks
    const unsigned int NB = gridDim.x;
*/
    
    const unsigned int idx = blockIdx.x * blockDim.x + threadIdx.x;

/*    sig1[tid] = (Complex)g_sig1[idx];
    sig2[tid] = (Complex)g_sig2[idx];
    __syncthreads();
    
    sigt[tid] = (Complex) ComplexMul((Complex)sig1[tid], (Complex)sig2[tid]);
    __syncthreads();
    
    g_sigt[idx] = (Complex)sigt[tid];
*/
/*
    sig1[tid] = g_sig1[idx];
    sig2[tid] = g_sig2[idx];
//    __syncthreads();
    
    sigt[tid] = ComplexMul(sig1[tid], sig2[tid]);
    __syncthreads();
    
    g_sigt[idx] = sigt[tid];
*/

    Complex a,b,c;
    
    a.x = (float)g_sig1[idx].x;
    a.y = (float)g_sig1[idx].y;
    
    b.x = (float)g_sig2[idx].x;
    b.y = (float)g_sig2[idx].y;

    c.x = (float)(  (float)a.x * (float)b.x - 
		    (float)a.y * (float)b.y );
    c.y = (float)(  (float)a.x * (float)b.y + 
		    (float)a.y * (float)b.x );

    g_sigt[idx] = (Complex)c;

/*
    Complex a,b,c;
    
    a.x = g_sig1[idx].x;
    a.y = g_sig1[idx].y;
    b.x = g_sig2[idx].x;
//    __syncthreads();
    c.x = a.x * b.x;
    c.y = a.y * b.x;
    
    b.y = g_sig2[idx].y;
//    __syncthreads();
    
    c.x -= a.y * b.y;
    c.y += a.x * b.y;
    
    sigt[tid] = c;
//    __syncthreads();
    g_sigt[idx] = sigt[tid];
*/

//
}
#endif // _CAF_KERNEL_H_


